org.springframework.http

## Class CacheControl

- java.lang.Object
- - org.springframework.http.CacheControl

-     public class CacheControl
      extends Object

  A builder for creating "Cache-Control" HTTP response headers.

  Adding Cache-Control directives to HTTP responses can significantly improve the client experience when interacting with a web application. This builder creates opinionated "Cache-Control" headers with response directives only, with several use cases in mind.

  - Caching HTTP responses with `CacheControl cc = CacheControl.maxAge(1, TimeUnit.HOURS)` will result in `Cache-Control: "max-age=3600"`
  - Preventing cache with `CacheControl cc = CacheControl.noStore()` will result in `Cache-Control: "no-store"`
  - Advanced cases like `CacheControl cc = CacheControl.maxAge(1, TimeUnit.HOURS).noTransform().cachePublic()` will result in `Cache-Control: "max-age=3600, no-transform, public"`

  Note that to be efficient, Cache-Control headers should be written along HTTP validators such as "Last-Modified" or "ETag" headers.

  Since:
    4.2
  Author:
    Brian Clozel, Juergen Hoeller
  See Also:
    rfc7234 section 5.2.2, HTTP caching - Google developers reference, Mark Nottingham's cache documentation

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `CacheControl()` Create an empty CacheControl instance.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `CacheControl` | `cachePrivate()` Add a "private" directive.
    `CacheControl` | `cachePublic()` Add a "public" directive.
    `static CacheControl` | `empty()` Return an empty directive.
    `String` | `getHeaderValue()` Return the "Cache-Control" header value, if any.
    `static CacheControl` | `maxAge(Duration maxAge)` Add a "max-age=" directive.
    `static CacheControl` | `maxAge(long maxAge, TimeUnit unit)` Add a "max-age=" directive.
    `CacheControl` | `mustRevalidate()` Add a "must-revalidate" directive.
    `static CacheControl` | `noCache()` Add a "no-cache" directive.
    `static CacheControl` | `noStore()` Add a "no-store" directive.
    `CacheControl` | `noTransform()` Add a "no-transform" directive.
    `CacheControl` | `proxyRevalidate()` Add a "proxy-revalidate" directive.
    `CacheControl` | `sMaxAge(Duration sMaxAge)` Add an "s-maxage" directive.
    `CacheControl` | `sMaxAge(long sMaxAge, TimeUnit unit)` Add an "s-maxage" directive.
    `CacheControl` | `staleIfError(Duration staleIfError)` Add a "stale-if-error" directive.
    `CacheControl` | `staleIfError(long staleIfError, TimeUnit unit)` Add a "stale-if-error" directive.
    `CacheControl` | `staleWhileRevalidate(Duration staleWhileRevalidate)` Add a "stale-while-revalidate" directive.
    `CacheControl` | `staleWhileRevalidate(long staleWhileRevalidate, TimeUnit unit)` Add a "stale-while-revalidate" directive.
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### CacheControl

          protected CacheControl()

      Create an empty CacheControl instance.
      See Also:
        `empty()`

  - ### Method Detail

    - #### empty

          public static CacheControl empty()

      Return an empty directive.

      This is well suited for using other optional directives without "max-age", "no-cache" or "no-store".

      Returns:
        `this`, to facilitate method chaining

    - #### maxAge

          public static CacheControl maxAge(long maxAge,
                                            TimeUnit unit)

      Add a "max-age=" directive.

      This directive is well suited for publicly caching resources, knowing that they won't change within the configured amount of time. Additional directives can be also used, in case resources shouldn't be cached (`cachePrivate()`) or transformed (`noTransform()`) by shared caches.

      In order to prevent caches to reuse the cached response even when it has become stale (i.e. the "max-age" delay is passed), the "must-revalidate" directive should be set (`mustRevalidate()`

      Parameters:
        `maxAge` - the maximum time the response should be cached
        `unit` - the time unit of the `maxAge` argument
      Returns:
        `this`, to facilitate method chaining
      See Also:
        `maxAge(Duration)`, rfc7234 section 5.2.2.8

    - #### maxAge

          public static CacheControl maxAge(Duration maxAge)

      Add a "max-age=" directive.

      This directive is well suited for publicly caching resources, knowing that they won't change within the configured amount of time. Additional directives can be also used, in case resources shouldn't be cached (`cachePrivate()`) or transformed (`noTransform()`) by shared caches.

      In order to prevent caches to reuse the cached response even when it has become stale (i.e. the "max-age" delay is passed), the "must-revalidate" directive should be set (`mustRevalidate()`

      Parameters:
        `maxAge` - the maximum time the response should be cached
      Returns:
        `this`, to facilitate method chaining
      Since:
        5.2
      See Also:
        rfc7234 section 5.2.2.8

    - #### noCache

          public static CacheControl noCache()

      Add a "no-cache" directive.

      This directive is well suited for telling caches that the response can be reused only if the client revalidates it with the server. This directive won't disable cache altogether and may result with clients sending conditional requests (with "ETag", "If-Modified-Since" headers) and the server responding with "304 - Not Modified" status.

      In order to disable caching and minimize requests/responses exchanges, the `noStore()` directive should be used instead of `#noCache()`.

      Returns:
        `this`, to facilitate method chaining
      See Also:
        rfc7234 section 5.2.2.2

    - #### noStore

          public static CacheControl noStore()

      Add a "no-store" directive.

      This directive is well suited for preventing caches (browsers and proxies) to cache the content of responses.

      Returns:
        `this`, to facilitate method chaining
      See Also:
        rfc7234 section 5.2.2.3

    - #### mustRevalidate

          public CacheControl mustRevalidate()

      Add a "must-revalidate" directive.

      This directive indicates that once it has become stale, a cache MUST NOT use the response to satisfy subsequent requests without successful validation on the origin server.

      Returns:
        `this`, to facilitate method chaining
      See Also:
        rfc7234 section 5.2.2.1

    - #### noTransform

          public CacheControl noTransform()

      Add a "no-transform" directive.

      This directive indicates that intermediaries (caches and others) should not transform the response content. This can be useful to force caches and CDNs not to automatically gzip or optimize the response content.

      Returns:
        `this`, to facilitate method chaining
      See Also:
        rfc7234 section 5.2.2.4

    - #### cachePublic

          public CacheControl cachePublic()

      Add a "public" directive.

      This directive indicates that any cache MAY store the response, even if the response would normally be non-cacheable or cacheable only within a private cache.

      Returns:
        `this`, to facilitate method chaining
      See Also:
        rfc7234 section 5.2.2.5

    - #### cachePrivate

          public CacheControl cachePrivate()

      Add a "private" directive.

      This directive indicates that the response message is intended for a single user and MUST NOT be stored by a shared cache.

      Returns:
        `this`, to facilitate method chaining
      See Also:
        rfc7234 section 5.2.2.6

    - #### proxyRevalidate

          public CacheControl proxyRevalidate()

      Add a "proxy-revalidate" directive.

      This directive has the same meaning as the "must-revalidate" directive, except that it does not apply to private caches (i.e. browsers, HTTP clients).

      Returns:
        `this`, to facilitate method chaining
      See Also:
        rfc7234 section 5.2.2.7

    - #### sMaxAge

          public CacheControl sMaxAge(long sMaxAge,
                                      TimeUnit unit)

      Add an "s-maxage" directive.

      This directive indicates that, in shared caches, the maximum age specified by this directive overrides the maximum age specified by other directives.

      Parameters:
        `sMaxAge` - the maximum time the response should be cached
        `unit` - the time unit of the `sMaxAge` argument
      Returns:
        `this`, to facilitate method chaining
      See Also:
        `sMaxAge(Duration)`, rfc7234 section 5.2.2.9

    - #### sMaxAge

          public CacheControl sMaxAge(Duration sMaxAge)

      Add an "s-maxage" directive.

      This directive indicates that, in shared caches, the maximum age specified by this directive overrides the maximum age specified by other directives.

      Parameters:
        `sMaxAge` - the maximum time the response should be cached
      Returns:
        `this`, to facilitate method chaining
      Since:
        5.2
      See Also:
        rfc7234 section 5.2.2.9

    - #### staleWhileRevalidate

          public CacheControl staleWhileRevalidate(long staleWhileRevalidate,
                                                   TimeUnit unit)

      Add a "stale-while-revalidate" directive.

      This directive indicates that caches MAY serve the response in which it appears after it becomes stale, up to the indicated number of seconds. If a cached response is served stale due to the presence of this extension, the cache SHOULD attempt to revalidate it while still serving stale responses (i.e. without blocking).

      Parameters:
        `staleWhileRevalidate` - the maximum time the response should be used while being revalidated
        `unit` - the time unit of the `staleWhileRevalidate` argument
      Returns:
        `this`, to facilitate method chaining
      See Also:
        `staleWhileRevalidate(Duration)`, rfc5861 section 3

    - #### staleWhileRevalidate

          public CacheControl staleWhileRevalidate(Duration staleWhileRevalidate)

      Add a "stale-while-revalidate" directive.

      This directive indicates that caches MAY serve the response in which it appears after it becomes stale, up to the indicated number of seconds. If a cached response is served stale due to the presence of this extension, the cache SHOULD attempt to revalidate it while still serving stale responses (i.e. without blocking).

      Parameters:
        `staleWhileRevalidate` - the maximum time the response should be used while being revalidated
      Returns:
        `this`, to facilitate method chaining
      Since:
        5.2
      See Also:
        rfc5861 section 3

    - #### staleIfError

          public CacheControl staleIfError(long staleIfError,
                                           TimeUnit unit)

      Add a "stale-if-error" directive.

      This directive indicates that when an error is encountered, a cached stale response MAY be used to satisfy the request, regardless of other freshness information.

      Parameters:
        `staleIfError` - the maximum time the response should be used when errors are encountered
        `unit` - the time unit of the `staleIfError` argument
      Returns:
        `this`, to facilitate method chaining
      See Also:
        `staleIfError(Duration)`, rfc5861 section 4

    - #### staleIfError

          public CacheControl staleIfError(Duration staleIfError)

      Add a "stale-if-error" directive.

      This directive indicates that when an error is encountered, a cached stale response MAY be used to satisfy the request, regardless of other freshness information.

      Parameters:
        `staleIfError` - the maximum time the response should be used when errors are encountered
      Returns:
        `this`, to facilitate method chaining
      Since:
        5.2
      See Also:
        rfc5861 section 4

    - #### getHeaderValue

          @Nullable
          public String getHeaderValue()

      Return the "Cache-Control" header value, if any.
      Returns:
        the header value, or `null` if no directive was added

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`